package cv8;

import java.util.Random;

/**
 *
 * @author juraj huska
 */
public class Graph {

    private Node[] nodesArray; // uzly grafu

    // matica suslednosti, cize hrany grafu
    //0 znaci ze tam hrana nieje, 1 ze tam je
    private int[][] adjacencyMatrix;

    private int numberOfNodes;

    private final int MAX_NUMBER_OF_NODES = 20;
    // poznamka: maximalny pocet hran je 20 x 20 pretoze uplny graf
    //na 20 prvkoch ma 20 na druhu hran.

    private int[] distance = new int[20];
    private int[] previous = new int[20];

    public Graph() {

        //inicializacia
        nodesArray = new Node[MAX_NUMBER_OF_NODES];

        adjacencyMatrix = new int[MAX_NUMBER_OF_NODES][MAX_NUMBER_OF_NODES];

        numberOfNodes = 0;

        //vsade bude nula ktora znaci ze medzi uzlom i,j nie je hrana
        for (int i = 0; i < MAX_NUMBER_OF_NODES; i++) {
            for (int j = 0; j < MAX_NUMBER_OF_NODES; j++) {

                adjacencyMatrix[i][j] = 0;
            }
        }
    }

    public void randomInit(){
        addNode("A");
        addNode("B");
        addNode("C");
        addNode("D");
        addNode("E");
        addNode("F");
        addNode("G");
        addNode("H");
        addNode("I");
        addNode("J");


        Random generator = new Random(System.currentTimeMillis() );
        int i,j;
        for (i = 0; i < 10; i++){
            System.out.print(i+" ");
            for (j = 0; j < 10; j++){
		if(i==j || generator.nextInt(10)%4 <= 2) adjacencyMatrix[i][j] = 0;
                else adjacencyMatrix[i][j] = generator.nextInt(9)+1;
		System.out.print(adjacencyMatrix[i][j]+" ");
            }
	    System.out.println();
        }
	System.out.println();
    }

    public void addNode(String labelOfNode) {

        if( numberOfNodes == MAX_NUMBER_OF_NODES ) {
            System.out.println("Unable to add node with label " + labelOfNode +
                    ", there is too much nodes in the array!");
            return;
        }
        //prida uzol do pola a zaroven zvysi pocet uzlov
        nodesArray[numberOfNodes++] = new Node(labelOfNode);
    }

    public void addEdge(int i, int j) {

        // prida hranu, je to neorientovany graf preto
        // hrana vedie aj z uzlu A do B a naopak
        adjacencyMatrix[i][j] = 1;
        adjacencyMatrix[j][i] = 1;
    }

    public void printNode(int indexOfNode) {

        System.out.print(nodesArray[indexOfNode].getLabelOfNode() + " ");
    }

    public void dijkstra(int startNodeIndex){
        // inicializace promenych a nastaveni vzdalenosti na inf

        // nastaveni vzdalenosti pro pocatecni uzel

        // dokud jsem neprosel vsechny uzly
            // tak nastavim hodnotu aktualniho (nejblizsiho) uzlu na visited
            // a v cyklu porovnám
                 // pokud existuje hrana
                   // pokud uzel nebyl navstiven
                     // pokud vzdalenost > nez vzdalenost z minimalniho uzlu + vzdalenost hrany
                       // tak uprav vzdalenost
                       // a nastav predchudce na aktualni uzel
        
    }
    /*
     Funkcee vyhleda uzel, ktery jeste nebyl navstiveny a jehoz vzdalenost (distance) je nejmensi mezi vsemi uzly

     */
    public int minimum(){

        return -1; //pokud nenajde zadny uzel vrati -1
    }

    public void printPath(int endNodeIndex){
    //pokud je zdalenost 0 tak vytisknu posledni uzel

    // pokud neni 0 a je 1000(inf) tak vypisu ze cesta neexistuje

    // pokud neni 1000 (inf) tak 1) zavolam rekurzivne na predchudci 2) vypisu " -> " a vypisu hodnotu uzlu
    }

    public int[] getDistance() {
        return distance;
    }

    public void setDistance(int[] distance) {
        this.distance = distance;
    }

    public int[] getPrevious() {
        return previous;
    }

    public void setPrevious(int[] previous) {
        this.previous = previous;
    }


}


